rticonnextdds-connector
=======

*(This repository hosts the common Connector native library and shouldn't be cloned.
See the **[Python](https://github.com/rticommunity/rticonnextdds-connector-py)** or
**[JavaScript](https://github.com/rticommunity/rticonnextdds-connector-js)** bindings.)*

### RTI Connector for Connext DDS - Getting Started
RTI Connext DDS is a software connectivity framework for real-time distributed applications. 
It uses the publish-subscribe communications model to make data distribution efficient and robust. 
At its core is the world’s leading ultra-high performance, distributed networking databus.

RTI Connector is a family of simplified APIs for publishing and subscribing to 
the Connext DDS Databus in programming languages such as Python and JavaScript.

*Connector* was created to quickly and easily develop demos
and proofs of concept. It can be useful for anybody who needs
a quick way to script tests and interact with Connext DDS using different scripting languages.

*Connector* can be used to quickly create tests for your distributed system and, thanks
to the binding with scripting languages and the use of XML, to easily integrate
with many other available technologies.

The *Connector* library is provided in binary form for selected architectures.
Scripting language bindings and examples are provided in source format.

### Language Support

 * **[Python](https://github.com/rticommunity/rticonnextdds-connector-py)** (Fully supported)
 * **[JavaScript](https://github.com/rticommunity/rticonnextdds-connector-js)** (Fully supported)
 * **[C#](https://github.com/rticommunity/rticonnextdds-connector-cs)** (Experimental support only)
 * **[Go](https://github.com/rticommunity/rticonnextdds-connector-go)** (Experimental support only)
 * **[Lua (through RTI Prototyper)](https://community.rti.com/downloads/experimental/rti-prototyper-with-lua)** (Experimental support only)
 * **[C](https://github.com/rticommunity/rticonnextdds-connector/tree/master/examples/lua_c_integration)** (Experimental support only)

### Support
If you have questions, use the [RTI Community Forum](https://community.rti.com/forums/technical-questions).

### License

(For Python and JavaScript, a different license in their respective repositories applies.)

This software is an experimental ("pre-production") product. The Software is provided "as is," with no warranty of any type, including any warranty for fitness for any purpose. RTI is under no obligation to maintain or support the software. RTI shall not be liable for any incidental or consequential damages arising out of the use or inability to use the software.
